<?php

class Data {
/** Данные должны возвращаться очень быстро. Убираем по максимуму все вычисления
*/
	private static $data; //потом как-то идентифицировать извлекаемые наборы данных и кэшировать
	private static $file;
	private static $empty = false;
	
	public static function get($subj, $where = null) {
		
		$model = Def::$model['essence'][$subj];
		self::$file = Def::check_path($model['file']);
		if (!$where) $where = Def::$request['where'];
		$type = esse($model, 'type');
		$table = $model['table'];
		
		$method = self::get_method($type, 'get'); #exit("$method, $type");
		$data = ($method) ? self::$method($subj, $table, $where) : $type::get($subj, $table, $where);
		#print_r($where);
		#echo $method, $subj, $type; exit;
		
		$fields = esse(Def::$model['fields'], $model['table']);
		if (empty($data) || !count($data)) {
			$data = array();
			self::$empty = true;
		}
		else self::normalize_values($data, $fields, true);
		$time_field = Def::find_key($fields, 'type', 'timestamp');
		
		$hash = var_export($data, true);
		#print_r($data);
		$arr = array(
			'time' => self::get_table_time($type, $table, $where, $time_field),
			'hash' => crc32($hash),
			'data' => $data,
			'length' => $hash,
			'empty' => self::$empty,
		);
		$match = esse(Def::$env, 'match');
		$since = esse(Def::$env, 'since');
		$time = gmdate("r", $arr['time']) . ' GMT';
		/* Определяем время и хэш по Главной сущности (всякие меню-информеры отдыхают) 
		* Опять же, если, например, будут комменты - их надо будет считать.
		*/
		if ($time == $since && $arr['hash'] == $match) exit(header(Def::$config['h304']));
		#print_r($arr);
		return $arr;
	}
	
	private static function get_method($type, $method) {
		$left_type = array('file', 'file_ini');
		return ($type && in_array($type, $left_type)) ? $method . '_' . $type : '';
	}
	
	public static function get_file_ini($table, $where = array()) {
		$f = self::$file;
		return (!empty($f) && file_exists($f)) ? parse_ini_file($f, true) : array();
	}
	
	public static function get_file($table, $where = array()) {
		$f = self::$file;
		//первая "строка", первая "ячейка"
		return (!empty($f) && file_exists($f)) ? array(array(implode(file($f)))) : array();
	}
	
	private static function get_table_time($type, $table, $where = array(), $time_field) {
		//exit(self::$file);
		return ($type != 'Mysql') ? filemtime(self::$file) : Mysql::get_time($table, $where, $time_field);
	}
	
	//********************** writable function ************************//
	
	private static function check_rights($status_write) {
		if (Def::$config['block_remote_write'] && Def::$env['server_ip'] != Def::$env['klient_ip']) return false;
		$status_user = esse(Def::$user, 'status');
		//echo "$status_user / $status_write" . ($status_user < $status_write);
		return (!$status_user || !$status_write || $status_user < $status_write) ? false : true;
	}
	
	public static function set_num_rows($subj) {
	
		$model = Def::$model['essence'][$subj];
		$type = esse($model, 'type');
		$table = esse($model, 'table');
		$arr = array();
		$num = null;
		if ($type == 'Xml') {
			$xml = Xml::get($subj, $arr);
			$num = count($xml);
		}
		else if ($type == 'Mysql') {
			$where = Def::get_key ($subj, $arr);
			$where = $where['where'];
			$num = Mysql::get_num_rows($table, $where);
			$num = ($num) ? 1 : 0;
		}
		if (!is_null($num)) {
			$arr = array('rows' => $num);
			$where = array('name' => $subj);
			Xml::write('essence', $arr, $where);
		}
	}
	
	public static function write($subj) {
		$model = Def::$model['essence'][$subj];
		$type = esse($model, 'type');
		$status_write = esse($model, 'status_w');
		if (!self::check_rights($status_write)) return 'not enough rights';
		
		$fields = Def::$model['fields'][$model['table']];
		self::normalize_values($_POST, $fields);
		//print_r($_POST); exit;
		$where = (isset($_POST['where'])) ? $_POST['where'] : array();
		$method = self::get_method($type, 'write'); 
		return ($method) ? self::$method($subj, $_POST['set'], $where) : $type::write($subj, $_POST['set'], $where);
		
	}
	
	public static function delete($arr) 
	{
		$subj = $arr['subj'];
		$model = Def::$model['essence'][$subj];
		$status_write = esse($model, 'status_w');
		if (!self::check_rights($status_write)) return 'not enough rights';
		
		$type = esse($model, 'type');
		$method = self::get_method($type, 'delete'); #exit("$method $type");
		return ($method) ? self::$method($arr) : $type::delete($arr);
	}
	
	public static function create_table($subj) {
	
		$model = Def::$model['essence'][$subj];
		$status_write = esse($model, 'status_w');
		if (!self::check_rights($status_write)) return array(0, 0, 'not enough rights');
		
		$type = esse($model, 'type');
		$method = self::get_method($type, 'create_table'); 
		return ($method) ? self::$method($subj) : $type::create_table($subj);
	}
	
	//********************** inner writable function ************************//
	
	public static function write_file_ini($subj, &$arr) {
		
		$model = Def::$model['essence'][$subj];
		$f = Def::check_path($model['file']);
		$str = '';
		foreach ($arr as $sect => $props) {
			$str .= '[' . $sect . ']' . CR;
			foreach ($props as $key => $value) {
				$str .= $key . '="' . addcslashes($value, '"') . '"' . CR;
			}
		}
		return (file_put_contents($f, $str)) ? 0 : '!file_put_contents ' . $f;
	}
	
	//********************** разное ************************//
	
	public static function js_unload($arr, $root = null, $f = null) {
		if (!$f) $f = SITE . '/dict.js';
		$js = 'if (!window.dict || typeof window.dict != object) window.dict = {};' . CR;
		$dict = 'dict';
		if ($root) $dict .= '.' . $root;
		$js .= Tpl::arr2js_hash($arr, $root);
		return (file_put_contents($f, $js)) ? 0 : '!file_put_contents';
		
	}
	
	public static function normalize_values(&$arr, &$fields, $out = false) {
		$gpc = (get_magic_quotes_gpc() || get_magic_quotes_runtime());
		#print_r($fields); print_r($arr); exit;
		foreach($arr as $key => $value) {
			if (is_array($value)) self::normalize_values($arr[$key], $fields, $out);
			else {
				if ($gpc && !$out) $arr[$key] = stripslashes($value);
				$func = esse($fields, $key, 'php');
				if ($func) {$arr[$key] = self::$func($value, $out);}
			}
		}
	}

	public static function check_gpc(&$arr) { //устарело?
		if (!get_magic_quotes_gpc() && !get_magic_quotes_runtime()) return false;
		foreach($arr as $key => $value) {
			if (is_array($value)) self::check_gpc($arr[$key]);
			else $arr[$key] = stripslashes($value);
		}
	}
	
	/***************** in-out functions для "нормализации" данных *******************/
	
	public static function md6($s, $out) {
		return ($out) ? $s : md5($s);
	}
	
	public static function date_Y($Y, $out) {
		return ($out) ? substr($Y, 0, 4) : $Y . '-01-01';
	}

}
