<?php

class Def 
{
	public static 
		$env = array(),
		$config = array(),
		$request = array(),
		$response = array(),
		$model = array(),
		$user = array(),
		$page = array();
	
	function __construct() {
			
		self::$config += array(
			'site_ini' => SITE . '/exe/site.ini', 
			'install' => SITE . '/exe/install.0', 
			'subjects_file' => LIB . '/subjects.xml', 
			'model_file' => LIB . '/model.xml', //обратная совместимость
			'sites_file' => LIB . '/sites.xml', 
			'fields_file' => LIB . '/fields.xml', 
			'users_file' => LIB . '/users.xml', 
			'admin_file' => LIB . '/admin.xml', 
			'sql_install_tables' => LIB . '/tables.sql', 
			'field_div' => ';', 
			'path_div' => ':',
			'uri_prefix' => '',
			'ext' => '.htm',
			'show_flag' => 'ru',
			'h304' => 'HTTP/1.x 304 Not Modified',
			'h404' => 'HTTP/1.x 404 Not Found',
			
		);
		self::$config['default_url'] = 'friends' . self::$config['ext'];
		
		foreach($_ENV as $k => $v) self::$env[$k] = $_ENV[$k];
		foreach($_SERVER as $k => $v) self::$env[$k] = $_SERVER[$k];
		
		$short_def = array(
			'host' => 'HTTP_HOST',
			'uri' => 'REQUEST_URI',
			'match' => 'HTTP_IF_NONE_MATCH',
			'since' => 'HTTP_IF_MODIFIED_SINCE',
			'agent' => 'HTTP_USER_AGENT',
			'script_path' => 'SCRIPT_FILENAME', 
			'referer' => 'HTTP_REFERER', 
			'server_ip' => 'SERVER_ADDR',
			'server_port' => 'SERVER_PORT',
			'klient_ip' => 'REMOTE_ADDR', 
			'docroot' => 'DOCUMENT_ROOT'
		);
		
		foreach($short_def as $k => $v) {
			$add = (isset(self::$env[$v])) ? self::$env[$v] : '';
			if (strpos($add, '\\') !== false) $add = str_replace('\\', '/', $add);
			self::$env[$k] = $add;
		}
		
		self::$config += parse_ini_file(self::$config['site_ini'], true);
		self::$config['mysql']['TZ_offset'] = (strtotime(date("Y-m-d H:i:s")) - strtotime(gmdate("Y-m-d H:i:s")))/60/60;
		
		$docroot = self::$env['docroot'];
		if (SITE != $docroot) self::$config['uri_prefix'] = str_ireplace($docroot, '', SITE); 

		self::$config['doctype'] = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">';
		self::$config['metas'] = '<meta http-equiv="Content-Type" content="text/html; charset=' . self::$config['site']['charset'] . '" />';
		self::$page += array(
			'head' => array(
				self::$config['metas'],
				'css' => '<link rel="stylesheet" href="' . self::$config['uri_prefix'] . '/site.css" type="text/css">',
			),
			'body' => '',
			
		);
		
		//местная коррекция
		$mesto = self::$env['docroot'] . '/../moe_mesto.php';
		$mesto_conf = (file_exists($mesto)) ? LIB . '/platforms/' . (include $mesto) . '.php' : null;
		if ($mesto_conf && file_exists($mesto_conf)) include($mesto_conf);
		
		self::$model['sites'] = Xml::get_arr(self::$config['sites_file']);
		self::$model['essence'] = Xml::get_arr(self::$config['subjects_file']);
		self::$model['fields'] = Xml::get_arr(self::$config['fields_file']);
		self::$model['essence']['config']['menu'] = (int) file_exists(self::$config['install']); 
		self::$model['essence']['instal']['menu'] = (int) file_exists(self::$config['install']); 
		//print_r(self::$model);
		self::$response = array(
			'css' => array('/site.css' => null),
			'js' => array(),
			'headers' => array(
				'Content-Type' => 'text/html; charset=' . self::$config['site']['charset'],
				'Last-Modified' => gmdate("r", time()) . ' GMT',
				'Expires' => gmdate("r", time()) . ' GMT',
				'Cache-Control' => 'private, max-age=0
',

			),
		);
		
	}
	
	public static function get_key ($essence, $arr) {
		$res = array('where' => array(), 'full_key' => false);
		#print_r($arr); exit($essence);
		$model = self::$model['essence'][$essence];
		$table = esse($model, 'table');
		$fields = esse(self::$model['fields'], $table);
		#print_r($arr); print_r($fields); exit($table . '/.');
		if (!$fields) return $res;
		//бывает "флаг": это поле в таблице, в котором указывается Сущность
		//(если в таблице хранится несколько Сущностей)
		$flag = esse($model, 'flag'); //echo $flag, $essence;
		if ($flag) {
			$arr = array($flag => $essence) + $arr;
		}
		if (!count($arr)) return $res;
		
		#print_r($arr); exit;
		//устанавливаем "путь" к набору Строк или к одной Строке:
		//выбираем из Данных "ключевые" значения
		foreach ($arr as $key => $value) { 
			$pk = esse($fields, $key, 'key');
			if ($pk == 1) $res['where'][$key] = $value;
		}
		//Проверяем полноту ключа (уникальность пути)
		$res['full_key'] = true;
		foreach ($fields as $key => $value) {
			$pk = esse($value, 'key');
			if ($pk == 1) {
				if (!isset($arr[$key]) || $arr[$key] == '') $res['full_key'] = false;
			}
		}
		#print_r($res);
		return $res;
	}
	
	
	public static function check_path ($s) {
		$s = explode(self::$config['path_div'], $s);
		//print_r($s);
		return (count($s) > 1) ? self::$config[$s[1]] : LIB . '/' . $s[0];
		//тут лажа зарыта ($config явно)
	}
	
	public static function parse_query ($url = null, $self = true) {
		
		if (is_null($url)) $url = self::$env['uri'];
		$url = str_ireplace('http://' . self::$env['host'], '', $url);
		$prefix = self::$config['uri_prefix'];
		if ($prefix) $url = str_ireplace($prefix, '', $url); 
		$url = preg_split("/\?/", $url);
		$query = esse($url, 1);
		$url = $url[0];
		
		if ($query) parse_str($query, $query); 
		$site = explode('/', $url);
		$url = array_pop($site);
		
		$site = implode('/', $site);
		$site = trim($site, '/');
		if (!$site) $site = 'public';
		if ($site == 'constructor') {
			Def::$config['default_url'] = 'sites' . Def::$config['ext'];
		}
		else if ($site == 'data') {
			Def::$config['default_url'] = 'enemies' . Def::$config['ext'];
		}
		if (!$url) $url = Def::$config['default_url'];
		
		//echo $site;
		$subj = explode('.', $url);
		$ext = (count($subj) > 1) ? array_pop($subj) : '';
		$subj = implode('.', $subj);
		
		$request =  array(
			'site' => $site,
			'file' => $url,
			'subj' => $subj,
			'ext' => $ext,
			'query' => $query,
			'where' => null,
			'full_key' => false,
		);
		if ($self) self::$request = $request;
		return $request;
	}
	
	public static function find_key($fields, $prop, $seek) {
		if (!$fields || !count($fields)) return null;
		foreach ($fields as $key => $props) {
			if (isset($props[$prop]) && $props[$prop] == $seek) return $key;
		}
		return null;
	}
	
	public static function e_404($str = '') {
		header('HTTP/1.x 404 Not Found');
		self::send_headers();
		$attrs = array();
		self::$page['head']['title'] = '<title>404 - страница не найдена</title>';
		exit(self::$config['doctype'] . implode(CR, self::$page['head']) 
	. '<div class="err c"><p>404: страница не найдена
	</p><p>' . $str . '</p><p> <a href="./">Главная</a> </p></div>');
	}

	public static function send_headers(){
		$headers = self::$response['headers'];
		foreach ($headers as $key => $value) {
			header($key . ': ' . $value);
		}
	}
	

	
}
