<?php

class Mysql {
	
	private static $conn = array();
	
	public static function connect($dsn = array()) {
		
		if (!count($dsn)) $dsn = Def::$config['mysql'];
		
		$user = esse($dsn, 'user');
		if (!$user) return null;
		$user = $dsn['bd_prefix'] . $user;
		if (!empty(self::$conn[$user])) return self::$conn[$user];
		
		$pw = esse($dsn, 'pw');
		$host = $dsn['host'];
		if (!empty($dsn['port']))  $host .= ':' . $dsn['port'];
		
		self::$conn[$user] = mysql_connect($host, $user, $pw);
		
		if (!empty($dsn['charset'])) {
			mysql_query('set names ' . $dsn['charset']);
		}

		if (!empty($dsn['bd'])) {
			$bd = $dsn['bd_prefix'] . $dsn['bd'];
			mysql_select_db($bd);
		}
		
		mysql_query("SET TIME_ZONE='+{$dsn['TZ_offset']}:00'");
		
		return self::$conn[$user];
	}
	
	public static function get($subj = null, $table, $where = '', $select = '*', $limit = 20) {
	    
	    $table = Def::$config['mysql']['table_prefix'] . $table;
	    $table = self::set_value($table, '`');
	    $select = self::build_select($select);
	    $where = self::build_where($where);
	    $limit = ' LIMIT ' . $limit;
	    $sql = $select . ' FROM ' . $table . $where . $limit;
	    
	    self::connect();
	    
	    return self::select_table($sql); 
	}

	public static function get_num_rows($table, $where) {
		
	    $table = Def::$config['mysql']['table_prefix'] . $table;
	    $table = self::set_value($table, '`');
	    $select = 'SELECT COUNT(*)';
	    $where = self::build_where($where);
	    $sql = $select . ' FROM ' . $table . $where;
	    
	    self::connect();
	    #exit($sql);
	    return self::select_cell($sql);
	}
	
	public static function get_time($table, $where, $time_field) {
		if (!$time_field) return time();
		$table = Def::$config['mysql']['table_prefix'] . $table;
		$table = self::set_value($table, '`');
		$select = 'SELECT MAX(' . self::set_value($time_field, '`') . ')';
		$where = self::build_where($where);
		$sql = $select . ' FROM ' . $table . $where;

		self::connect();
		$res = self::select_cell($sql);
		return ($res) ? strtotime($res) : time(); 
	}
	
	public static function select_cell($sql, $skip_err = false) {
		$r = self::get_resource($sql, $skip_err);
		return ($r[1]) ? mysql_result($r[0], 0, 0) : null;
	}

	public static function select_row($sql, $skip_err = false){
		$r = self::get_resource($sql, $skip_err);
		return ($r[1]) ? mysql_fetch_assoc($r[0]) : null;
	}

	public static function select_col($sql, $skip_err = false) {
		$r = self::get_resource($sql, $skip_err);
		$arr = array();
		if (!$r[1]) return $arr;
		while ($row = mysql_fetch_row($r[0])) {
			$arr[] = $row[0];
		}
		return $arr;
	}

	public static function select_table($sql, $skip_err = false){
		$r = self::get_resource($sql, $skip_err);
		$t = array();
		if (!$r[1]) return $t;
		
		$j = 0;
		while ($row = mysql_fetch_assoc($r[0])) {
			$j ++;
			$t[$j] = array();
			foreach ($row as $key => $value) {
				$t[$j][$key] = $value;
			}
		}
		return $t;
	}

	private static function get_resource($sql, $skip_err = false) {
	    $r = mysql_query($sql);
	    $err = mysql_error();
	    if ($err) {
	        $n = false;
	        $err_vis = $sql . '; ERROR: ' . $err;
	        if (!$skip_err) exit(View::print_error($err_vis, true));
	        else $r = $err_vis;
	    }
	    else $n = (is_resource($r)) ? mysql_num_rows($r) : false;
	    return array($r, $n); 
	}

	private static function build_select($arr, $noslovo = false){
	    $selectstr = '';
	    $slovo = ($noslovo === false) ? 'SELECT ' : '';
	    if (!is_array($arr)) return $slovo . $arr;
		
	    $comma = '';
	    foreach($arr as $field) {
	        $field = mysql_escape_string($field);
	        $field = str_replace('.', '`.`', $field);
	        $selectstr .= "{$comma}`$field` ";
	        $comma = ', ';
	    }
		
	    $selectstr = ($selectstr) ? " {$slovo}$selectstr " : '';
	    return $selectstr;
	}

	private static function build_where($where, $nowhere = false){ 
	    $wherestr = '';
	    if (!is_array($where)) return $wherestr;
	    $comma = '';
	    foreach($where as $key => $val) {
	        if (is_array($val)) {
	            $value = (isset($val['value'])) ? $val['value'] : $val;
	            $case = (isset($val['case'])) ? self::set_value($val['case'], "") : '=';
	        }
	        else {
	            $value = $val;
	            $case = '=';
	        }
	        $value = self::set_value($value, "'");
	        $field = mysql_escape_string($key);
	        $field = str_replace('.', '`.`', $field);
	        $wherestr .= "{$comma}`$field` {$case} $value";
	        $comma = ' AND ';
	    }
	    $where_slovo = ($nowhere === false) ? ' WHERE ' : '';
	    $wherestr = ($wherestr) ? " {$where_slovo}($wherestr) " : '';
	    return $wherestr;
	}

	private static function set_value($val, $quot) {
	    $v = false;
	    if (is_array($val) && isset($val['func'])) {
	        $v = "{$val['func']}(";
	        $comma = '';
	        foreach($val['param'] as $p) {
	            $quot = (isset($p[1])) ? $p[1] : '';
	            $par = mysql_escape_string($p[0]);
	            $v .= "$comma{$quot}$par{$quot}";
	            $comma = ', ';
	        }
	        $v .= ")";
	    }
	    else {
	        $v = mysql_escape_string($val);
	        $v = "{$quot}$v{$quot}";
	    }
	    return $v;
	}
	
	/**======================== writable functions =============*/
	
	public static function write($subj, $arr, $where) {
		$model = Def::$model['essence'][$subj];
		$table = $model['table'];
		$fields = Def::$model['fields'][$table];
		$table = Def::$config['mysql']['table_prefix'] . $table;
		#print_r($where); echo '/' . Def::$request['full_key']; exit;
		if (Def::$request['full_key']) {
			$method = 'UPDATE ';
			$where = self::build_where($where);
		}
		else {
			$method = 'REPLACE INTO ';
			$where = '';
		}
		$set = '';
		$comma = '';
		foreach ($arr as $key => $value) {
			$set .= $comma . self::set_value($key, '`') . '=' . self::set_value($value, '\'');
			$comma = ', ';
		}
		$sql = $method . self::set_value($table, '`') . ' SET ' . $set . ' ' . $where;
		#exit($sql);
		self::connect();
		$ok = self::query($sql); 
		return ($ok[2]) ? 0 : ('some error on write Mysql: <br><br>' . implode(CR, $ok));
	}
	
	public static function delete($arr) {
		$subj = $arr['subj'];
		$model = Def::$model['essence'][$subj];
		$table = $model['table'];
		$fields = Def::$model['fields'][$table];
		$table = Def::$config['mysql']['table_prefix'] . $table;
		$where = $arr['query'];
		$where = self::build_where($where);
		$sql = 'DELETE FROM ' . self::set_value($table, '`') . $where . ' LIMIT 1';
		#exit($sql);
		self::connect();
		$ok = self::query($sql); 
		return ($ok[2]) ? 0 : ('some error on delete Mysql: <br><br>' . implode(CR, $ok));
	}
	
	public static function create_table($subj) {
		
		$model = Def::$model['essence'][$subj];
		$table = $model['table'];
		$fields = Def::$model['fields'][$table];
		$table = Def::$config['mysql']['table_prefix'] . $table;
		
		$key_def = array(1 => 'UNIQUE KEY', 2 => 'PRIMARY KEY');
		$sql = 'CREATE TABLE IF NOT EXISTS ' . self::set_value($table, '`') . '(' . CR;
		$keys = array();
		$comma = '';
		foreach ($fields as $key => $props) {
			$k = esse($props, 'key');
			if ($k) {
				if (!isset($keys[$k])) $keys[$k] = array();
				$keys[$k][] = $key;
			}
			$sql .= $comma . self::set_value($key, '`') . ' ' . $props['type'] . ' ' . $props['default'] . ' ' . $props['extra'];
			$comma = ',' . CR;
		}
		if (count($keys)) {
			foreach ($keys as $type => $names) {
				$name = self::set_value($names[0], '`');
				$type = (array_key_exists($type, $key_def)) ? $key_def[$type] : 'KEY';
				$sql .= $comma . $type . ' ' . $name . ' (`' . implode('`, `', $names) . '`)';
			}
		}
		$sql .= ') ENGINE=MyISAM DEFAULT CHARSET=cp1251;' . CR;
		self::connect();
		return self::query($sql); 
	}
	
	public static function query($sql) {
		//exit($sql);
		$r = mysql_query($sql) or exit(mysql_error());
		if (is_resource($r)) {
			$ret = array($r, mysql_num_rows($r));
		}
		else {
			$ret = array(mysql_info(), mysql_affected_rows(), $sql);
		}
		return $ret;
	}
}