<?php

class Tpl {
	
	public static function page() {
		$arr = Def::$page;
		$attr = array();
		$arr['head']['title'] = View::htpl(2, 'title', $attr, $arr['head']['title']);
		//перекрытие
		$default = array(
			'doctype' => Def::$config['doctype'],
			'head' => implode(CR, $arr['head']),
			'body_attrs' => esse($arr, 'body_attrs'),
			'header' => esse($arr, 'header'),
			'msg_user' => esse($arr, 'msg_user'),
			'menu' => esse($arr, 'menu'),
			'body' => esse($arr, 'body'),
			'footer' => esse($arr, 'footer'),
		);
		//вот и весь "интерфейс"!
		
		extract($default);
		$site = esse(Def::$request, 'site');
		if ($site) $site = ' ' . $site;
		
		return <<<TPL
{$doctype}
<head>
	{$head}
</head>
<body{$body_attrs}>
	<div class="page{$site}">
	{$header}
	{$msg_user}
	<div class="menutop">{$menu}</div>
	{$body}
	{$footer}
	</div>
</body>

TPL;
	} //function tpl_page
	
	public static function table(&$arr) {
		//перекрытие
		$default = array(
			'table' => esse($arr, 'table'),
			'caption' => esse($arr, 'caption'),
			'cols' => esse($arr, 'cols'),
			'thead' => esse($arr, 'thead'),
			'tbody' => esse($arr, 'tbody'),
		);
		
		extract($default);
	return <<<TPL
<table class="{$table}">
	<caption>{$caption}</caption>
	<colgroup>{$cols}</colgroup>
	<thead>{$thead}</thead>
	<tbody>{$tbody}</tbody>
</table>
TPL;
	}
	
	public static function item($item) {
		return <<<TPL
<div class="item">
	
	{$item}
</div>
TPL;
	}
	
	public static function footer(&$arr = array()) {
		
		return <<<TPL
	<div class='footer'>
	<h4><a href='./repa/'>дистрибутивы</a> маленького фреймворка (версии)</h4>
	<p><a href='http://ir2.ru/quiproquo.aspx'>Что из чего следует во фреймворке «Friends»</a> (общая схема, 29.10.11)</p>
	<p><a href='http://ir2.ru/php_framework.aspx'>php-фреймворк анти-MVC-ООП</a>, описание (17.10.11)</p>
	</div>
TPL;
	}
	
	public static function arr2js_hash($arr, $root = 'dict') {
		$js = '';
		//$js = '{ ' . CR;
		$comma = '';
		$open = ($root) ? '' : '{';
		$close = ($root) ? '' : '}';
		foreach ($arr as $k => $v) {
			$js .= ($root) ? (CR . $root . '.' . def_e($k) . ' = {') : ($comma . def_e($k) . ': ');
			$js .= (is_array($v)) ? ($open . self::arr2js_hash($v, null) . $close) : ('"' . def_e($v) . '"');
			$comma = ', ';
			if ($root) $js .= '} ';
		}
		$js .= CR;
		return $js;
	} //function arr2js_hash

	function arr2js_arr($arr, $root = 'dict') { //!!заготовка
		$js = '[ ' . CR;
		$comma = '';
		foreach ($arr as $v) {
			$js .= $comma;
			$js .= (is_array($v)) ? arr2js_arr($v) : ('"' . def_e($v) . '"');
			$comma = ', ';
		}
		$js .= '] ' . CR;
		return $js;
	} //function arr2js_arr
	
	function js($src, $value) {
		
		if (strpos($src, '/') === 0) $src = Def::$config['uri_prefix'] . $src;
		$src = ($value) ? '' : ' src="' . $src . '"';
		return <<<TPL
<script type="text/javascript"{$src}>$value</script>
TPL;
	}

	function css($href, $value) {
		if (strpos($href, '/') === 0) $href = Def::$config['uri_prefix'] . $href;
		if ($value) return <<<TPL
<style type="text/css">$value</style>
TPL;
		else return <<<TPL
<link rel="stylesheet" href="{$href}" type="text/css">
TPL;
	}
	

	function create_table_mysql($name, $fields) {
		return <<<TPL
CREATE TABLE if not exists `msgs` (
  `id` int(11) NOT NULL auto_increment,
  `metka` tinyint(3) NOT NULL default '1',
  `name` varchar(30) NOT NULL default '',
  `email` varchar(100) default NULL,
  `msg` varchar(255) NOT NULL default '',
  `datrec` timestamp NULL default CURRENT_TIMESTAMP,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=cp1251;
TPL;
	}

} //class