<?php

class View {
	
	protected $data;
	protected $fields = array();
	protected $subj;
	protected $view;
	protected $show_flag;
	
	function __construct($subj = null, $view = null) {
		
		$admin = (Def::$request['site'] == 'data' || Def::$request['site'] == 'constructor') ? true : false;
		if (is_null($subj)) $subj = Def::$request['subj'];
		
		$model = Def::$model['essence'][$subj];
		$data = Data::get($subj);
		
		if (is_null($view)) {
			if ($data['empty']) {
				if ($admin) $view = 'write_form';
				else exit(Def::e_404()); //Вообще-то сюда мы попадать не должны (Контроллер не должен пустить)
			}
			else {
				if (!empty($model['view'])) $view = $model['view']; //приоритет явного указания!
				else $view = (Def::$request['full_key']) 
					? ($admin ? 'write_form' : 'item') 
					: 'table';
			}
		}
		
		self::dehtml($data); //убить всё на (<, ", '). Позже добавить if
		
		$show_flag = esse($model, 'show_flag'); //не все поля нужно отображать
		if (!$show_flag) $show_flag = Def::$config['show_flag'];
		
		$this->show_flag = $show_flag;
		$this->subj = $subj;
		$this->view = $view;
		$this->data = $data;
		#print_r($data);
		#exit($view);
		Def::$response['headers']['Etag'] = $data['hash'];
		Def::$response['headers']['Last-Modified'] = gmdate("r", $data['time']) . ' GMT';
		$this->out($data, $view, $admin);
	}
	
	private function find_func($data) {
		//запускаем ф-цию только для уникально выбранной записи
		if (!Def::$request['full_key']) return null;
	
		$essence = Def::$model['essence'][$this->subj];
		
		$data = each($data['data']);
		$data = $data['value'];
		
		return esse($data, 'func');
	}
	
	private function out($data, $view, $admin) {
		//exit($this->subj);
		$model = Def::$model['essence'][$this->subj];		
		$table = $model['table'];
		
		
		Def::$page['head']['title'] = $model['title'];
		#print_r(Def::$request);
		if (Def::$request['full_key']) {
			$row = each($data['data']);
			$row = $row['value'];
			
			$title = esse($row, 'title');
			if (!$title) $title = esse($row, 'name');
			
			if ($title) Def::$page['head']['title'] .= ', ' . $title;
		}
		else {
			foreach(Def::$request['where'] as $key => $value)
				if ($value != $this->subj) Def::$page['head']['title'] .= ', ' . $value;
		}
		
		$source = esse($model, 'type');
		if ($source) Def::$page['head']['title'] .= ' (source: ' . $source . ')';
		
		Def::$page['msg_user'] = $this->build_msg_user();
		Def::$page['menu'] = $this->build_menu();
		
		
		$method = 'build_' . $view;
		
		$func = $this->find_func($data);
		if ($func) $class = new $table;
		Def::$page['body'] .= ($func && $class && !$admin) ? $class->$func() : $this->$method($table);
		//exit(Def::$page['body']);
		$add = esse($model, 'add');
		if ($add && !$func) {
			$add = explode(Def::$config['field_div'], $add);
			
			foreach ($add as $subj) {
				$c_view = esse(Def::$model['essence'], $subj, 'view');
				
				$this->data = Data::get($subj);
				//print_r($this->data);
				$method = 'build_' . $c_view;
				Def::$page['body'] .= $this->$method();
			}
		}
				
		$site = Def::$request['site'];
		if ($site) {
			$method = esse(Def::$model['sites'][$site], 'action');
			if ($method) Def::$page['body'] .= $this->$method();
		}
		
		Def::$page['footer'] = (Def::$request['full_key']) ? '' : Tpl::footer();
		
		$js =& Def::$response['js'];
		if (count($js)) $js = array('/common.js' => null, '/dict.js' => null) + $js;
		Def::$page['head']['js'] = self::build_jscss($js, 'js');
		
		$css =& Def::$response['css'];
		Def::$page['head']['css'] = self::build_jscss($css, 'css');
		
		Def::send_headers();
		#ob_start("setContentLength");
		#ob_start("ob_gzhandler");
		print Tpl::page();
	}
	
	private function build_jscss(&$arr, $tpl) {
		$str = '';
		
		foreach ($arr as $key => $value) {
			$str .= Tpl::$tpl($key, $value);
		}
		return $str;
	}
	
	private function build_raw() {
		
		$data = $this->data;
		//print_r($data);
		$str = $data['data'][0][0];
		$attrs = array();
		return self::htpl(2, 'pre', $attrs, $str);
	}
	
	private function build_msg_user() {
		$user = Def::$user;
		if (!count($user)) return '';
		$attrs = array('href' => 'auth.com');
		$out = self::htpl(2, 'a', $attrs, 'Выход');
		$attrs = array('class' => 'msg_user');
		return self::htpl(2, 'span', $attrs, '[' . $user['fullname'] . '] ' . '[' . $user['status'] . '] ' . $out);
	}
	
	private function build_constructor_menu(){
		if (esse(Def::$user, 'status') < 2) return '';
		$arr = Def::$model;
		self::dehtml($arr); 
		$ext = Def::$config['ext'];
		$menu = array();
		//print_r($arr);
		foreach ($arr['essence'] as $subj => $props) {
			$table = esse($props, 'table');
			$file = $subj . Def::$config['ext'];
			if ($file == Def::$request['file'] && !count(Def::$request['where'])) $file = false;
			$title = (!empty($props['title'])) ? $props['title'] : $subj;
			
			$fields_title = ($table && isset($arr['fields'][$table])) ? $table : 'СОЗДАТЬ';
			$fields_href = 'fields' . $ext . '?table=' . urlencode($table) . (('СОЗДАТЬ' == $fields_title) ? '&name=id' : '');
			
			$data_file = esse($props, 'file');
			if ($data_file && strpos($data_file, ':') !== false) {
				$data_file = explode(':', $data_file);
				$data_title0 = $data_file[1];
				$data_file = Def::$config[$data_file[1]];
			}
			$data_title = ($data_file && file_exists($data_file)) ? $data_title0 : 'СОЗДАТЬ';
			$data_href = 'create_table.com' . '?essence=' . urlencode($props['name']);
			
			$menu[] = array(
				'subj' => array('href' => 'essence' . $ext . '?name=' . urlencode($subj), 'text' => $title),
				'fields' => array('href' => ($table) ? $fields_href : '', 'text' => $fields_title),
				'data' => array('href' => ($data_file) ? $data_href : '', 'text' => $data_title),
			);
		}
		//print_r($menu);
		$out = array();
		$attrs = array('href' => 'essence' . $ext);
		$link_essence = self::htpl(2, 'a', $attrs, 'essence');
		$attrs = array('href' => 'fields' . $ext);
		$link_fields = self::htpl(2, 'a', $attrs, 'fields');
		$attrs = array('href' => Def::$config['uri_prefix'] . '/data/');
		$link_data = self::htpl(2, 'a', $attrs, 'data');
		$html = '<div class="menu_constr"><table><tr><td>' . $link_essence . '</td><td>' . $link_fields . '</td><td>' . $link_data . '</td></tr>' . CR;
		foreach($menu as $arr) {
			$html .= '<tr>';
			foreach ($arr as $link) {
				$html .= '<td>';
				$attrs = array('href' => esse($link, 'href'));
				$attrspan = array();
				$html .= (!empty($link['href'])) 
					? self::htpl(2, 'a', $attrs, $link['text'])
					: self::htpl(2, 'span', $attrspan, 'none');
				$html .= '</td>';
			}
			$html .= '</tr>' . CR;
		}
		$html .= '</table></div>' . CR;
		return $html;
	}
	
	private function build_menu() {
	
		$essence = Def::$model['essence'];
		$prefix = Def::$config['uri_prefix'] . '/'; 
		$admin = esse(Def::$user, 'status'); 
		
		$menu_type = array('Mysql', 'xml');
		$menu = array();
		$site = Def::$request['site'];
		if ($site == 'data' || $site == 'constructor') {
			$menu[] = array('href' => $prefix, 'text' => 'В начало'); 
			$prefix = '';
		}
		else {
			$menu[] = array('href' => 'data/', 'text' => 'Данные');
			$menu[] = array('href' => 'constructor/', 'text' => 'Конструктор');
		}
		foreach ($essence as $subj => $arr) {
			//print_r($arr); exit($flag . '/');
			$file = $subj . Def::$config['ext'];
			if ($file == Def::$request['file'] && !Def::$request['query']) $file = null;
			$flag = ($admin) ? (($arr['type'] == 'Mysql' || in_array(esse($arr, 'type'), $menu_type) && 2 == $admin) ? true : false) 
				: ((esse($arr, 'menu')) ? true : false);
			if ($flag) $menu[] = array('href' => $file, 'text' => def_e($arr['title']));
			
		}
		//print_r($menu);
		$out = array();
		foreach($menu as $arr) {
			$attrs = array('href' => $prefix . esse($arr, 'href'));
			$attrspan = array();
			$out[] = (!is_null($arr['href'])) 
				? self::htpl(2, 'a', $attrs, $arr['text'])
				: self::htpl(2, 'span', $attrspan, $arr['text']);
		}
		return implode(' | ', $out);
	}
		
	//subclass Table
	public static function bred_crumbs($base, $arr, $vis_div = ' / ', $href_div = '&') {
		//всё держится на том, что в Модели первой всегда идёт Таблица, а только потом - Наименование поля
		$str = '';
		$curr_item = each($arr);
		
		while ($next = each($arr)) {
			$attrs = array('href' => $base);
			$base .= urlencode($curr_item['key']) . '=' . urlencode($curr_item['value']) . $href_div;
			$str .= $vis_div . self::htpl(2, 'a', $attrs, $curr_item['value']);
			$curr_item = $next;
		}
		return $str . $vis_div . $curr_item['value'];
	}
	
	private function build_auth_form($table) {
		$subj = $this->subj;
		$fields = Def::$model['fields'][$subj];
		$str = '<div class="form">
		<form action="auth.com" method="post">' . CR
		. '<p class="r">Имя: admin, пароль: admin</p>' . CR;
		foreach ($fields as  $key => $props) {
			if (!esse($props, 'list')) continue;
			$vis_name = esse($props, 'ru');
			if (!$vis_name) continue; //жёсткий отбор: и по list, и по ru. М.б. здесь нужен вообще произвольный, но как?
			$type = ($key == 'password') ? 'password' : 'text';
			$str .= $this->build_input('where[' . $key . ']', '', $type, $vis_name) . CR;
		}
		$form_base = array('essence' => $subj);
		foreach ($form_base as $key => $value) {
			$str .= $this->build_input($key, $value, 'text', $key, 'span', 'h6') . CR;
		}
		$str .= '<br>' . $this->build_input('go', 'Войти', 'submit', '', '') . CR;
		$str .= '</form></div>' . CR;
		return $str;
	}
	
	private function build_write_form() {
		$ext = Def::$config['ext'];
		$subj = $this->subj;
		$table = Def::$model['essence'][$subj]['table'];
		$type = Def::$model['essence'][$subj]['type'];
		//if (!Def::$request['full_key'] && !$this->data['empty']) return $this->build_table($table);
		$data = $this->data['data'];
		//print_r($data);
		$row = each($data); 
		if (!$row) {
			$row = array_keys(Def::$model['fields'][$table]);
			//print_r($row);
			$row = array_flip($row);
			if ($subj == 'fields') {
				foreach ($row as &$value) $value = '';
				$row['type'] = 'varchar(30)';
				$row['list'] = 1;
			}
		}
		else $row = $row['value']; 
		//print_r(Def::$request['where']);
		//$subj_row = esse($row, 'name') ;
		$attrs = array('href' => $subj . $ext);
		$bred_cr = self::htpl(2, 'a', $attrs, $subj)
			. self::bred_crumbs($subj . $ext . '?', Def::$request['where']);
		$str = '<div class="form"><form action="write.com" method="post">' . CR;
		$attrs = array();
		$str .= self::htpl(2, 'h3', $attrs, $bred_cr) . CR;
		$table_link = esse($row, 'table');
		foreach ($row as $key => $value) {
			$attrs = array('href' => 'fields' . $ext . '?table=' . $table_link . '&name=' . $key);
			$vis_name = ($subj == 'fields') ? $key : self::htpl(2, 'a', $attrs, $key);
			$str .= $this->build_input('set[' . $key . ']', $value, 'text', $vis_name) . CR;
		}
		//$addon = array('essence' => $this->subj, 'table' => $table);
		//if ($table_link) $table = $table_link;
		
		$form_where = Def::$request['where'];
		#print_r($form_where);
		foreach ($form_where as $key => $value) {
			$str .= $this->build_input('where[' . $key . ']', $value, 'text', $key, 'span', 'h5') . CR;
		}
		
		$form_base = array('essence' => $subj);
		foreach ($form_base as $key => $value) {
			$str .= $this->build_input($key, $value, 'text', $key, 'span', 'h6') . CR;
		}
		
		if ($type == 'Xml') {
			$str .= $this->build_input('xml_path', implode(':', $form_where), 'text', 'xml_path', 'span', 'h6') . CR;
		}
		
		$str .= '<br>' . $this->build_input('go', 'Сохранить', 'submit', '', '') . CR;
		$str .= '</form></div>' . CR;
		return $str;
	}
	
	private function build_table($table) {
		
		$subj = $this->subj;
		$arr = array();
		$arr['caption'] = Def::$page['head']['title'];
		
		$head = $this->build_head($table);
		$arr['table'] = $table;
		$arr['thead'] = $head['thead'];
		$arr['cols'] = $head['cols'];
		$arr['tbody'] = $this->build_tbody($this->data, $table);

		return Tpl::table($arr);
	}
	
	private function fields_for_list($table) {
		/** Выбирает поля из Модели, которые должны отображаться при выводе в виде таблицы */
		$fields = $this->fields;
		
		if (isset($fields[$table])) return $fields[$table];
		
		$head = array();
		$fields = esse(Def::$model['fields'], $table);
		//print_r($fields);
		if ($fields) {
			foreach ($fields as $field => $prop) {
				if (empty($prop['list'])) continue;
				$head[$field] = $prop;
			}
		}
		$this->fields[$table] = $head;
		return $head;
	}
	
	private function build_head($table) {
		$show_flag = $this->show_flag;
		$head = $this->fields_for_list($table);
		//print_r($head);
		$thead = '<tr>';
		$cols = '';
		$attrs_empty = array('class' => 'msg');
		if (count($head)) {
			foreach($head as $field => $prop) {
				
				if (!empty($prop[$show_flag])) {
					$attrs = array('class' => $field);
					$thead .= self::htpl(2, 'th', $attrs, $prop[$show_flag]);
					$cols .= self::htpl(1, 'col', $attrs);
				}
			}
		}
		else $thead .= self::htpl(2, 'th', $attrs_empty, 'Нет описания полей для ' . $table);
		$thead .= '</tr>'; 
		return array('thead' => $thead, 'cols' => $cols);
	}
	
	private function build_get(&$arr){
		$str = '';
		foreach ($arr as $key => $value) {
			$str .= urlencode($key) . '=' . urlencode($value) . '&';
		}
		return $str;
	}
	
	private function build_tbody($data, $table) {
		$show_flag = $this->show_flag;
		$subj = $this->subj;
		$thead = $this->fields_for_list($table);
		$f = Def::$request['file'];
		$tbody = $data['data'];
		$str = '';
		//print_r($tbody);
		foreach($tbody as $row) {
			
			$str .= '<tr>';
			foreach($thead as $field => $prop) {
				if (!empty($prop[$show_flag])) {
/*!!*/					$value = def_e($row[$field]); 
					$extra = null;
					$tpl = null;
					$link = esse($prop, 'link');
					if ($link == 1) { //а что ещё там может быть?.. (1 - primary key)
						$pk = Def::get_key($subj, $row);
						$pk = $pk['where']; #print_r($pk);
						$extra = urlencode($f) . '?' . $this->build_get($pk);
						$tpl = 'a';
						$attrs = array('href' => $extra);
					}
					//$value = array($value, $extra, $tpl);
					$html = (!empty($tpl)) 
					? self::htpl(2, $tpl, $attrs, $value) 
					: $value;
					$attrs = array();
					$str .= self::htpl(2, 'td', $attrs, $html);
				}
			}
			$str .= '</tr>';
		}
		
		return $str;
	
	} //subclass Table
	
	//subclass Item (list, именованный список)
	
	private function build_item($table) {
		
		$fields = Def::$model['fields'][$table];
		$data = $this->data['data'];
		if (!count($data)) return 'Нет данных';
		$item = each($data); 
		$item = $item['value']; 
		
		$str = '';
		$alt = '';
		
		foreach ($item as $key => $value) {
			
			
			$name = esse($fields[$key], $this->show_flag);
			if (!$name) continue;
			
			$attrs = array();
			$html = self::htpl(2, 'strong', $attrs, $name) . ': ' . $value;
			$str .= self::htpl(2, 'p', $attrs, $html);
		}
		$alt = each($item);
		$alt = $alt['value']; 
		
		if (Def::$request['full_key']) {
			$src = Def::$request['where'];
			rsort($src);
			$src = implode('_', $src);
			$img = 'img/' . $src . '.gif';
			$attrs = array('src' => $img, 'alt' => $alt);
			if (file_exists(SITE . '/' . $img))
				$str .= self::htpl(1, 'img', $attrs);
		}
		
		return Tpl::item($str);;
	} //subclass Item
	
	//subclass form_ini
	
	private function build_form_ini() {
		$data = $this->data['data'];
		
		$str = '<form action="write.com" method="post">' . CR;
		
		foreach ($data as $sect => $props) {
			if (!is_array($props)) continue; //выкидываем параметры вне секций на
			$attrs = array();
			$str .= '<div>' . self::htpl(2, 'h3', $attrs, $sect);
			foreach ($props as $key => $value) {
				$str .= $this->build_input('set[' . $sect . ']' . '[' . $key . ']', $value, 'text', $key) . CR;
			}
			$str .= '</div>' . CR;
		}
		$str .= $this->build_input('essence', $this->subj, 'hidden', '', '') . CR;
		$str .= '<br>' . $this->build_input('', 'Сохранить', 'submit', '', '') . CR;
		$str .= '</form>' . CR;
		return $str;
	}
	
	private function build_input($key, $value, $type = 'text', $view_name, $key_tag = 'span', $row_tag = 'p') {
		if (!isset($view_name)) $view_name = $key;
		$str = '';
		$attrs = array();
		if ($key_tag) $str .= self::htpl(2, $key_tag, $attrs, $view_name . ': ');
		$attrs = array('name' => $key, 'value' => $value, 'type' => $type);
		$str .= self::htpl(1, 'input', $attrs); 
		$attrs = array();
		return self::htpl(2, $row_tag, $attrs, $str);
	}//subclass form_ini
	
	public static function create_table($subj) {
		
		$r = Data::create_table($subj);
		
		$msg = (is_array($r)) ? 'Затронуто строк: '. $r[1] . '. Запрос:' . CR . $r[2]
			: $r; 
		self::print_error($msg);
		exit();
	}
	
	public static function seek($subj) {
		
		$data = Data::seek($subj);
		if ($subj != 'users') {print_r($data); exit;} //потом придумаем, что с этим делать
		else self::set_auth($data);
		#if (!$err) header('Location: ' . Def::$env['referer']);
		#else self::print_error($err);
	}
	
	public static function write($subj) {
		
		$err = Data::write($subj); //exit($err);
		if (!$err) {
			Data::set_num_rows($subj);
			header('Location: ' . Def::$env['referer']);
		}
		else self::print_error($err);
	}
	
	public static function delete($subj) {
		$url = Def::$env['referer'];
		$request = Def::parse_query($url, false);
		#print_r($request); exit($subj);
		$err = Data::delete($request);
		if (!$err) {
			Data::set_num_rows($request['subj']);
			header('Location: ' . Def::$env['referer']);
		}
		else self::print_error($err);
	}
	
	public static function js_unload() {
		$essence = Def::$model['essence']['essence'];
		$f = Def::check_path($essence['file']);
		$arr = Xml::get_arr($f);
		
		$err = Data::js_unload($arr, 'dict');
		if (!$err) header('Location: ' . Def::$env['referer']);
		else self::print_error($err);
	}
	
	public static function print_error($err) {
		Def::send_headers();
		$attrs = array('class' => 'err');
		print Def::$config['doctype'] . implode(CR, Def::$page['head']) . self::htpl(2, 'div', $attrs, $err);
	}
	
	public static function htpl($mode, $tag, &$attributes = array(), $child = '') {
		$gt = ($mode == 2) ? '>' : ' />';
		$attrs = '';
		foreach ($attributes as $key => $attr) $attrs .= ' ' . self::e($key) . '="' . self::e($attr) . '"';
		$el = '<' . $tag . $attrs . $gt;
		if ($mode == 2) $el .= $child . '</' . $tag . '>';
		return $el;
		
	}
	
	public static function e($x) {
		$in = array('"', "'", '<');
		$out = array('&#34;', "&#39;", '&lt ;');
		return str_replace($in, $out, $x);
	}
	
	public static function dehtml(&$arr) {
		foreach ($arr as $key => $value) {
			if (is_array($value)) self::dehtml($value);
			else $arr[$key] = self::e($value);
		}
	}
	
} //class View